#!/bin/bash
argument="$1"
#
# Domoticz control for Daikin airconditioner/Heatpump systems with 
# online wifi controller.
# For this script to work you need to have installed curl and jq
# Read the post or wiki for installation instructions
#
# This script comes with no warranty ...use at own risk 
# Copyright (C) 2015  Peter H. Roubos, you can use this script or parts of this scripts to
# your own liking, but please share your edits and or comments with the community.
# 
# This program is free software; you can redistribute it and/or modify 
# it under the terms of the GNU General Public License as published by 
# the Free Software Foundation; version 2 of the License. 
# 
# This program is distributed in the hope that it will be useful, 
# but WITHOUT ANY WARRANTY; without even the implied warranty of 
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
# GNU General Public License for more details. 
# 
# I use it in Domoticz but should work on every linux system
# Version 1.0 03/27/2015
#
# Change variables to your liking here

# Settings:
# Daikin IP Adress
	DIP=192.168.1.xx

# Domoticz port
	DomPort=8080

# On/Off button idx
	OoIdx=xx

# Temp idx
	TempIdx=xx

############################################################
# NO CHANGES AFTER THIS LINE ## NO CHANGES AFTER THIS LINE #
############################################################


control="/aircon/get_control_info"
sensors="/aircon/get_sensor_info"
DomOo=`curl -s "http://127.0.0.1:$DomPort/json.htm?type=devices&rid=$OoIdx" | jq '.result[0].Data'  | tr -d '"' `
DomTemp=`curl -s "http://127.0.0.1:$DomPort/json.htm?type=devices&rid=$TempIdx" | jq '.result[0].Data'  | tr -d '"' `
ControlInfoPath=http://$DIP$control
SensorsInfoPath=http://$DIP$sensors
ControlInfo=$(curl -s $ControlInfoPath)
SensorsInfo=$(curl -s $SensorsInfoPath)

# Get relevant control information from Daikin
ControlInfo=${ControlInfo//,/ [}
ControlInfo='['${ControlInfo//=/]=}
eval declare -A pump=($ControlInfo)

pow=( ${pump[pow]} )
mode=( ${pump[mode]} )
stemp=( ${pump[stemp]} )
shum=( ${pump[shum]} )
f_rate=( ${pump[f_rate]} )
f_dir=( ${pump[f_dir]} )


# Get Sensor information
SensorsInfo=${SensorsInfo//,/ [}
SensorsInfo='['${SensorsInfo//=/]=}
eval declare -A DaiSens=($SensorsInfo)

htemp=( ${DaiSens[htemp]} )
otemp=( ${DaiSens[otemp]} )
hhum=( ${DaiSens[hhum]} )

if [ $pow = "1" ]; then
Daipow=On
else
Daipow=Off
            fi
			
if [ $DomOo = "On" ]; then
Dompow=1
else
Dompow=0
            fi

if [ $argument = "check" ]; then

	if [ $Dompow != $pow ]; then
		curl  "http://127.0.0.1:$DomPort/json.htm?type=command&param=switchlight&idx=$OoIdx&switchcmd=$Daipow"
		fi
	
	if [ $stemp != $DomTemp ]; then
		curl  "http://127.0.0.1:$DomPort/json.htm?type=command&param=udevice&idx=$TempIdx&nvalue=0&svalue=$stemp"
		fi
	
else
curl --data "pow=$Dompow&mode=4&stemp=$DomTemp&shum=0&f_rate=A&f_dir=0" http://$DIP/aircon/set_control_info
	fi
	

